DECLARE SUB Put.Free (egy%, keto%, nn%)
DECLARE SUB Last.Card ()
DECLARE SUB Can.Play (i%, j%)
DECLARE SUB Move.Stack (from.col%, to.col%, down.to%)
DECLARE SUB Unmove (down.to%)
DECLARE SUB Auto.Solve ()
DECLARE SUB Auto.Assist ()
DECLARE SUB Change.Color ()
DECLARE SUB Move.Many (i%, j%, m%, n%, k%)
DECLARE SUB new.game ()
DECLARE SUB Show.Board ()
DECLARE SUB Must.Move ()
DECLARE FUNCTION Move.All% (i%, j%, m%, n%)
DECLARE FUNCTION Must.Play% (i%, j%)
DECLARE FUNCTION Move.One% (i%, j%, m%, n%)
DECLARE FUNCTION Move.Anything% (i%, j%, m%, n%)
DECLARE FUNCTION Scan$ (x$, z$)
DECLARE FUNCTION Trim$ (x$)
'
DEFINT A-Z
CLEAR , , 25000

DIM savegame(19, 8), layout(19, 8), moves(900, 4), lastcard(8)
DIM pip$(13), suit$(4), colorset(9, 3, 1), files$(99)

REM  spade, heart, diamond, club     100,200,300,400
suit$ = "": FOR i = 1 TO 4: suit$(i) = MID$(suit$, i, 1): NEXT i
suit$(0) = " "
REM  A, 2, 3, 4, 5, 6, 7, 8, 9, 0, J, Q, K      1-13
pip$ = "A234567890JQK": FOR i = 1 TO 13: pip$(i) = " " + MID$(pip$, i, 1): NEXT i
pip$(10) = "10": pip$(0) = "  ": search.count = 0: leavefree = 0

' default colors
DATA 2,2,2,7,2,3,0,2,0,7,0,3,4,2,4,7,4,3,4,2,4,7,4,3,0,2,0,7,0,3,11,2,11,7,11,3,14,2,14,7,14,3,7,0,7,0,7,3

FOR i = 0 TO 7: FOR j = 1 TO 3: FOR k = 0 TO 1
 READ color.set(i, j, k)
NEXT k: NEXT j: NEXT i

GOTO usedefault
ON ERROR GOTO usedefault

OPEN "colors.fcc" FOR INPUT AS 1
FOR i = 0 TO 7: FOR j = 1 TO 3: FOR k = 0 TO 1
 INPUT #1, color.set(i, j, k)
NEXT k: NEXT j: NEXT i
CLOSE 1

usedefault:
ON ERROR GOTO 0
'ON ERROR GOTO error.trap
RANDOMIZE TIMER
file.name$ = "lastgame.fc"
file.name$ = COMMAND$
IF LEN(file.name$) = 0 THEN CALL new.game: GOTO start.game
OPEN file.name$ FOR INPUT AS 1
FOR i = 0 TO 19: FOR j = 1 TO 8: INPUT #1, layout(i, j): NEXT j: NEXT i
CLOSE 1

' ***************************************************************************
start.game:

FOR i = 1 TO 4: layout(0, i) = 0: layout(0, 4 + i) = 100 * i: NEXT
FOR i = 0 TO 19: FOR j = 1 TO 8: savegame(i, j) = layout(i, j): NEXT j: NEXT i
youdeal = 0: picki = 0: pickj = 0: highi = 7: highj = 1: move.no = 0: automove! = 0
funckey = 0
CALL Last.Card
OPEN "lastgame.fc" FOR OUTPUT AS 1
FOR i = 0 TO 19: FOR j = 1 TO 8: PRINT #1, savegame(i, j): NEXT j: NEXT i
CLOSE 1
COLOR color.set(7, 1, 0), color.set(7, 1, 1)

refresh.screen:
COLOR color.set(7, 1, 0), color.set(7, 1, 1): CLS
COLOR color.set(5, 1, 0), color.set(5, 1, 1): LOCATE 1, 1, 1, 31, 31
      '         1         2         3         4         5         6         7
      '12345678901234567890123456789012345678901234567890123456789012345678901234567890
PRINT "ͻ"' 1
PRINT "      1   2   3   4   5   6   7   8         Free Cells      "' 2
PRINT "    Ŀ   Ŀ   "' 3
PRINT "  1                                           "' 4
PRINT "  2                               "' 5
PRINT "  3                                Collected       "' 6
PRINT "  4                            Ŀ   "' 7
PRINT "  5                                           "' 8
PRINT "  6                               "' 9
PRINT "  7                                       Ŀ   "'10
PRINT "  8                              # Moves:        "'11
PRINT "  9                                          "'12
PRINT " 10                            F1: Help            "'13
PRINT " 11                            F2: Restart         "'14
PRINT " 12                            F3: New Deal        "'15
PRINT " 13                            F4: You Deal        "'16
PRINT " 14                            F5: Auto Assist     "'17
PRINT " 15                            F6: Auto Solve      "'18
PRINT " 16                            F7: Save Deal       "'19
PRINT " 17                            F8: Load Old Deal   "'20
PRINT " 18                            F9: Change colors   "'21
PRINT " 19                            F10: Undo Last Play "'22
PRINT "ͼ"'23
COLOR color.set(6, 1, 0), color.set(6, 1, 1)
LOCATE 2, 46: PRINT "Free Cells";
LOCATE 6, 46: PRINT "Collected";
LOCATE 11, 44: PRINT "# Moves:";
LOCATE 23, 23: PRINT file.name$
IF youdeal THEN
 LOCATE 16, 46: PRINT "You Deal"
END IF

IF search! THEN
 automove! = 1
 CALL Auto.Solve
 OPEN "freecell.txt" FOR APPEND AS 1
 PRINT #1, DATE$; TIME$; " tried:"; search!; " used:"; move.no
 LOCATE 1, 80: search.count = LOF(1) / 43
 CLOSE #1
 IF layout(0, 5) + layout(0, 6) + layout(0, 7) + layout(0, 8) = 1052 AND search! < 100000 THEN
 ELSE
  IF search! THEN
   temp$ = TIME$
   file.name$ = "NO" + LEFT$(temp$, 2) + MID$(temp$, 4, 2) + RIGHT$(temp$, 2) + ".fc"
   OPEN file.name$ FOR OUTPUT AS 1
   FOR i = 0 TO 19: FOR j = 1 TO 8: PRINT #1, savegame(i, j): NEXT j: NEXT i
   CLOSE 1
  ELSE
   GOTO refresh.screen
  END IF
 END IF
 CALL new.game
 GOTO start.game
END IF

' loop forever
DO WHILE -1
 CALL Show.Board      ' why not? can't hurt
 IF youdeal THEN LOCATE 24, 1: PRINT "Press F4 to go to next column";
 oldmove = 0          ' don't show solution
 stopatstep = 0

' loop for next key stroke
DO WHILE in$ = "": in$ = INKEY$: LOOP
a$ = in$: in$ = "": t! = TIMER
IF LEN(a$) = 1 AND a$ <> CHR$(27) AND youdeal = 0 THEN DO WHILE TIMER - t! < .3 AND in$ = "": in$ = INKEY$: LOOP
IF a$ = in$ THEN in$ = "": a$ = CHR$(9)
IF (LEN(a$) < 2) AND funckey <> 0 AND a$ <> CHR$(27) THEN
 a$ = CHR$(0) + CHR$(58 + funckey): funckey = 0
END IF
'IF a$ = " " THEN a$ = CHR$(0) + CHR$(77)' turn space bar into right arrow
IF LEN(a$) < 2 THEN
 a = ASC(UCASE$(a$))
 IF a = 27 THEN  ' ESC
  END
 ELSEIF INSTR("12345678", a$) THEN
  highi = 1: highj = a - 48
  IF pickj THEN
   IF pickj = a - 48 THEN
    pickj = 0
   ELSE
    IF Move.Anything(picki, pickj, highi, highj) THEN pickj = 0: CALL Must.Move
   END IF
  ELSE
   pickj = a - 48: picki = 1
  END IF
 ELSEIF a = 9 THEN ' TAB  = double click
  both.same = NOT ((picki = 0) XOR (highi = 0))
  IF (highj = pickj AND both.same) OR pickj = 0 THEN
   IF highi THEN
    temp = Move.Anything(highi, highj, 0, 1)
    IF lastcard(highj) > 0 THEN highi = lastcard(highj) ELSE pickj = 0
   ELSE  ' highi = 0  (is a freecell)
    FOR j = 1 TO 8     ' try to put it into a non empty row
     IF lastcard(j) <> 0 AND layout(0, highj) <> 0 THEN temp = Move.Anything(highi, highj, 1, j)
    NEXT j
    FOR j = 1 TO 8     ' try to put it into an empty row
     IF lastcard(j) = 0 AND layout(0, highj) <> 0 THEN temp = Move.Anything(highi, highj, 1, j)
    NEXT j
    IF pickj THEN IF layout(-(picki <> 0), pickj) = 0 THEN pickj = 0
   END IF
   CALL Must.Move
  ELSE  ' another card has been picked
   IF highi THEN
    IF layout(1, highj) THEN pickj = highj: picki = highi
   ELSE
    IF layout(0, highj) THEN pickj = highj: picki = highi
   END IF
  END IF
 ELSE
  ' play this card
  IF youdeal THEN
   IF layout(highi, highj) THEN
    picki = lastcard(pickj) + 1
    IF NOT Move.One(highi, highj, picki, pickj) THEN
     picki = picki + 1
     IF picki > 19 THEN pickj = pickj + 1: picki = 1
    END IF
   END IF
  ELSE
   both.same = NOT ((picki = 0) XOR (highi = 0))
   IF pickj = highj AND both.same THEN
    pickj = 0
   ELSEIF pickj = 0 THEN
    IF highi = 0 THEN
     IF highj > 4 OR layout(highi, highj) = 0 THEN GOTO refresh.screen
    ELSE
     IF layout(1, highj) = 0 THEN GOTO refresh.screen
    END IF
    picki = highi: pickj = highj
   ELSE
    IF Move.Anything(picki, pickj, highi, highj) THEN pickj = 0
   END IF
   CALL Must.Move
  END IF
 END IF
ELSE
 a = ASC(MID$(a$, 2))
 IF a = 115 THEN a = 71
 IF a = 116 THEN a = 73
 '----------------------------------------------' f1 --------------------------
 IF a = 59 THEN
  COLOR color.set(7, 1, 0), color.set(7, 1, 1)
  COLOR color.set(5, 1, 0), color.set(5, 1, 1)
  LOCATE 6, 3: PRINT " ͻ"
  LOCATE 7, 3: PRINT "   To select a card:                                             "
  LOCATE 8, 3: PRINT "      move cursor to a column, press Enter.                      "
  LOCATE 9, 3: PRINT "      cursor changes color.                                      "
  LOCATE 10, 3: PRINT "                                                                 "
  LOCATE 11, 3: PRINT "   To move a selected card:                                      "
  LOCATE 12, 3: PRINT "      move cursor to another column or free cell, press Enter.   "
  LOCATE 13, 3: PRINT " Ŀ"
  LOCATE 14, 3: PRINT "  DOS Freecell copyright notice:                               "
  LOCATE 15, 3: PRINT "  This program was written by Julius Nadas <from scratch.>     "
  LOCATE 16, 3: PRINT "  All use, including use for profit is permitted, all I        "
  LOCATE 17, 3: PRINT "  ask is that you include this copyright notice in a form      "
  LOCATE 18, 3: PRINT "  that can be viewed by the user.                              "
  LOCATE 19, 3: PRINT "                (c) 1999 by Julius Nadas                       "
  LOCATE 20, 3: PRINT "                    jnadas@ccc.edu                             "
  LOCATE 21, 3: PRINT " ٺ"
  LOCATE 22, 3: PRINT " ͼ"
  DO: a$ = INKEY$: LOOP UNTIL LEN(a$) > 0
  GOTO refresh.screen
 '----------------------------------------------' f2 --------------------------
 ELSEIF a = 60 THEN
  FOR i = 0 TO 19: FOR j = 1 TO 8: layout(i, j) = savegame(i, j): NEXT j: NEXT i
  GOTO start.game
 '----------------------------------------------' f3 --------------------------
 ELSEIF a = 61 THEN
  CALL new.game
  GOTO start.game
 '----------------------------------------------' f4 --------------------------
 ELSEIF a = 62 THEN
  IF youdeal THEN
   pickj = pickj + 1: IF pickj < 9 THEN picki = lastcard(pickj) + 1 ELSE pickj = 0: GOTO start.game
  ELSEIF pickj THEN
   IF picki THEN
    picki = lastcard(pickj): IF picki = 0 THEN picki = 1
    IF highi THEN highi = lastcard(highj) + 1
    IF layout(picki, pickj) THEN IF Move.One(picki, pickj, highi, highj) THEN GOTO start.game
   END IF
  ELSE
   youdeal = -1: picki = 1: pickj = 1: highi = 7: highj = 5: move.no = 0
   FOR j = 1 TO 8: lastcard(j) = 0: NEXT j
   FOR j = 1 TO 4: layout(0, j) = 0: NEXT
   FOR j = 1 TO 4: layout(0, 4 + j) = 100 * j: NEXT
   FOR i = 1 TO 19: FOR j = 1 TO 8: layout(i, j) = 0: NEXT j: NEXT i
   FOR i = 1 TO 13: FOR j = 1 TO 4: layout(6 + i, 4 + j) = j * 100 + i: NEXT j: NEXT i
  END IF
 '----------------------------------------------' f5 --------------------------
 ELSEIF a = 63 THEN
  automove! = -1
  CALL Auto.Assist
  automove! = 0
  LOCATE 24, 1: PRINT "            ";
 '----------------------------------------------' f6 --------------------------
 ELSEIF a = 64 THEN
  automove! = 1
  x$ = STR$(leavefree)
  ' x$ = Scan("Leave free cells", STR$(leavefree))
  IF LEN(x$) THEN leavefree = VAL(x$): CALL Auto.Solve: oldmove = move.no
 '----------------------------------------------' f7 --------------------------
 ELSEIF a = 65 THEN
  COLOR color.set(7, 1, 0), color.set(7, 1, 1): CLS
  PRINT "         <<<<<<<<<<<<<   Enter file name to SAVE   >>>>>>>>>>>>>"
  ON ERROR GOTO save.ignore
  FILES "*.fc"
just.save:
  ON ERROR GOTO error.trap
  LINE INPUT "Enter File Name:"; file.name$
  IF INSTR(file.name$, ".") THEN file.name$ = LEFT$(file.name$, INSTR(file.name$, "."))
  file.name$ = Trim$(file.name$) + ".fc"
  OPEN file.name$ FOR OUTPUT AS 1
  FOR i = 0 TO 19: FOR j = 1 TO 8: PRINT #1, layout(i, j): NEXT j: NEXT i
  CLOSE 1
  GOTO refresh.screen
save.ignore:
  RESUME just.save
 '----------------------------------------------' f8 --------------------------
 ELSEIF a = 66 THEN
  COLOR color.set(5, 1, 0), color.set(5, 1, 1): CLS
  LOCATE 25, 28: PRINT "ͼ";
  LOCATE 1, 1
        '12345678901234567890123456789012345678901234567890123456789012345678901234567890
  PRINT "ͻ"
  '      xxxxxxxxxx.fc xxxxxxxxxx.fc xxxxxxxxxx.fc xxxxxxxxxx.fc xxxxxxxxxx.fc
  FOR i = 1 TO 20
   PRINT "                                                                     "
  NEXT i
  PRINT "ͼ"
  LOCATE 23, 28: PRINT "ͻ";
  LOCATE 24, 28: PRINT " Enter file number     ";
  SHELL "dir /o/b/l *.fc > fc.dir"
  OPEN "fc.dir" FOR INPUT AS #1: nn$ = ""
  DO
  FOR i = 0 TO 99
   INPUT #1, files$(i)
   LOCATE (i MOD 20) + 2, (i \ 20) * 16 + 2
   PRINT USING "##\         \"; i; files$(i);
   IF EOF(1) THEN EXIT FOR
  NEXT i
  IF i > 99 THEN i = 99
  COLOR color.set(6, 1, 0), color.set(6, 1, 1)
  LOCATE 24, 30: PRINT "Enter file number";
  INPUT nn$:
  COLOR color.set(5, 1, 0), color.set(5, 1, 1)
  IF LEN(nn$) <> 0 THEN EXIT DO
  LOOP WHILE NOT EOF(1)
  IF LEN(nn$) = 0 OR VAL(nn$) < 0 OR VAL(nn$) > i THEN
   file.name$ = "lastgame.fc"
  ELSE
   file.name$ = files$(VAL(nn$))
  END IF
  CLOSE #1

  'IF INSTR(file.name$, ".") THEN file.name$ = LEFT$(file.name$, INSTR(file.name$, "."))
  'file.name$ = Trim$(file.name$) + ".fc"
  OPEN file.name$ FOR INPUT AS 1
  FOR i = 0 TO 19: FOR j = 1 TO 8: INPUT #1, layout(i, j): NEXT j: NEXT i
  CLOSE 1
  GOTO start.game
 '----------------------------------------------' f9 --------------------------
 ELSEIF a = 67 THEN
  CALL Change.Color
  GOTO refresh.screen
forgetit: RESUME refresh.screen
 '---------------------------------------------' f10 -------------------------
 ELSEIF a = 68 THEN
  IF move.no > 0 THEN CALL Unmove(move.no - 1)
 '--------------------------------------------' shift F1 ---------------------
 ELSEIF a = 84 THEN
  SYSTEM
 '--------------------------------------------' shift F3 ---------------------
 ELSEIF a = 86 THEN
  LOCATE 21, 63: PRINT "   Stop at";
  LOCATE 22, 63: PRINT "-------------";
  LOCATE 23, 63: INPUT "  step"; stopatstep
  automove! = 1
  CALL Auto.Solve
 '--------------------------------------------' shift F4 ---------------------
 ELSEIF a = 87 THEN
  IF youdeal THEN
   pickj = pickj - 1
   IF pickj < 1 THEN pickj = 8
   picki = lastcard(pickj) + 1
  ELSE
   search! = 1
   GOTO refresh.screen
  END IF
 '--------------------------------------------' shift F5 ---------------------
 ELSEIF a = 88 THEN
  test = -1: automove! = -1
  CALL Auto.Assist
  test = 0: automove! = 0
  LOCATE 24, 1: PRINT "            ";
 '--------------------------------------------' shift F6 ---------------------
 ELSEIF a = 89 THEN
  test = -1: automove! = 1
  x$ = Scan("Leave free cells", STR$(leavefree))
  IF LEN(x$) THEN leavefree = VAL(x$): CALL Auto.Solve: oldmove = move.no
  test = 0
 '--------------------------------------------' shift F9 ---------------------
 ELSEIF a = 92 THEN
  test = NOT test
 '--------------------------------------------' shift F10 --------------------
 ELSEIF a = 93 THEN
  IF move.no > 0 THEN CALL Unmove(VAL(Scan$("Undo to move number", STR$(move.no - 1))))
 '--------------------------------------------' some other function ----------
 ELSEIF a > 83 THEN
  STOP
 '--------------------------------------------' cursor movement --------------
 '======================== highlighted function keys
 ELSEIF funckey THEN
  IF a = 71 THEN                        ' Home
   funckey = 0: highi = 1: highj = 1
  ELSEIF a = 72 THEN                    ' up
   funckey = funckey - 1: IF funckey = 0 THEN highi = 1: highj = 1
  ELSEIF a = 73 THEN                    ' PgUp
   funckey = 0: highi = 0: highj = 4
  ELSEIF a = 75 THEN                    ' left
   highi = funckey + 9: highj = 8: funckey = 0
  ELSEIF a = 77 THEN                    ' right
   highi = funckey + 9: highj = 1: funckey = 0
  ELSEIF a = 79 THEN                    ' end
   highi = lastcard(8): highj = 8: funckey = 0
  ELSEIF a = 80 THEN                    ' down
   funckey = funckey - (funckey < 10)
  ELSEIF a = 81 THEN                    ' PgDn
   highi = lastcard(1): highj = 1: funckey = 0
  END IF
  COLOR color.set(5, 1, 0), color.set(5, 1, 1)
  LOCATE 13, 42: PRINT "F1: Help           "
  LOCATE 14, 42: PRINT "F2: Restart        "
  LOCATE 15, 42: PRINT "F3: New Deal       "
  LOCATE 16, 42: PRINT "F4: You Deal       "
  LOCATE 17, 42: PRINT "F5: Auto Assist    "
  LOCATE 18, 42: PRINT "F6: Auto Solve     "
  LOCATE 19, 42: PRINT "F7: Save Deal      "
  LOCATE 20, 42: PRINT "F8: Load Old Deal  "
  LOCATE 21, 42: PRINT "F9: Change colors  "
  LOCATE 22, 42: PRINT "F10: Undo Last Play"
 ' =============================== you are not dealing the cards
 ELSEIF NOT youdeal THEN
 ' Home
 IF a = 71 THEN
  IF highj = 1 THEN highi = 1 ELSE highj = 1
 ' Up
 ELSEIF a = 72 THEN
  IF highi = 0 THEN
   IF highj > 4 THEN highj = highj - 4 ELSE highj = highj + 4
  ELSEIF highi = 1 THEN
   highi = 19
  ELSE
   highi = highi - 1
  END IF
 ' Pg Up
 ELSEIF a = 73 THEN
  IF highi = 0 OR highj = 8 THEN highi = 0: highj = 4 ELSE highj = 8
 ' left
 ELSEIF a = 75 THEN
  IF highj > 1 AND (highi > 0 OR highj <> 5) THEN
   highj = highj - 1
  ELSEIF highi = 0 THEN
   IF highj < 5 THEN highi = 1: highj = 8 ELSE highi = 5: highj = 8
  ELSEIF highj = 1 THEN
   IF highi < 4 THEN
    highi = 0: highj = 4
   ELSEIF highi < 10 THEN
    highi = 0: highj = 8
   ELSE
    funckey = highi - 9: highi = 0: highj = 0
   END IF
  END IF
 ' right
 ELSEIF a = 77 THEN
  IF highj < 8 AND (highi > 0 OR highj <> 4) THEN
   highj = highj + 1
  ELSEIF highi THEN
   IF highi < 4 THEN
    highi = 0: highj = 1
   ELSEIF highi < 10 THEN
    highi = 0: highj = 5
   ELSE
    funckey = highi - 9: highi = 0: highj = 0
   END IF
  ELSE
   IF highj = 4 THEN highi = 1 ELSE highi = 5
   highj = 1
  END IF
 ' end
 ELSEIF a = 79 THEN
  IF highi = 0 THEN highj = 5 ELSE highi = lastcard(1): highj = 1
 ' down
 ELSEIF a = 80 THEN
  IF highi THEN
   highi = highi + 1: IF highi > 19 THEN highi = 1
  ELSEIF highj < 5 THEN
   highj = highj + 4
  ELSE
   highj = 0: funckey = 1
  END IF
 ' PgDn
 ELSEIF a = 81 THEN
  IF highi = 0 THEN highj = 8 ELSE highi = lastcard(8): highj = 8
 END IF
 END IF
END IF

IF youdeal AND a <> 87 AND a <> 62 THEN
 IF funckey <> 0 THEN highi = funckey + 9: highj = 5: funckey = 0
 IF highi = 0 THEN highi = 6: highj = 5
 DO
  IF a = 72 THEN          '  (up)
   IF highi > 7 THEN highi = highi - 1 ELSE highi = 19: highj = highj - 1: IF highj < 5 THEN highi = 19: highj = 8
  ELSEIF a = 75 THEN      '  (left)
   IF highj > 5 THEN highj = highj - 1 ELSE highj = 8: highi = highi - 1: IF highi < 7 THEN highi = 19: highj = 8
   EXIT DO
  ELSEIF a = 77 THEN      '  (right)
   IF highj < 8 THEN highj = highj + 1 ELSE IF highi < 19 THEN highj = 5: highi = highi + 1
   EXIT DO
  ELSEIF a = 80 THEN      '  (down = 80)
   IF highi < 19 THEN highi = highi + 1 ELSE IF highj < 8 THEN highi = 7: highj = highj + 1
  ELSE
   EXIT DO
  END IF
 LOOP WHILE (highi > 7 OR highj > 5) AND (highj < 8 OR highi < 19) AND layout(highi, highj) = 0
END IF

IF oldmove THEN
 ' we had just finished an auto solve..
 LOCATE 24, 1: PRINT "            ";
 IF layout(0, 5) + layout(0, 6) + layout(0, 7) + layout(0, 8) = 1052 THEN
  FOR i = 0 TO 19: FOR j = 1 TO 8: layout(i, j) = savegame(i, j): NEXT j: NEXT i
  move.no = 0
  CALL Last.Card
  FOR re.move = 1 TO oldmove
   highi = moves(re.move, 1): highj = moves(re.move, 2)
   CALL Show.Board
   LOCATE 24, 1: PRINT 1 + oldmove - remove; "moves.";
   ' PRINT moves(re.move, 1); moves(re.move, 2); moves(re.move, 3); moves(re.move, 4);
   PRINT " Show? <Y/N/G> "; : DO: a$ = INKEY$: LOOP WHILE LEN(a$) = 0
   which = 0
   WHILE INSTR("0123456789", a$)
    PRINT a$; : which = 10 * which + VAL(a$)
    DO: a$ = INKEY$: LOOP WHILE LEN(a$) = 0
    IF a$ = CHR$(8) THEN which = 0
   WEND
   LOCATE 24, 1: PRINT SPACE$(50); : a$ = UCASE$(a$)
   IF INSTR("N" + CHR$(27), a$) THEN EXIT FOR
   IF "G" = a$ THEN
    LOCATE 24, 1:
    INPUT ; "Go to move"; which
   END IF
   WHILE re.move < which
    IF Move.One(moves(re.move, 1), moves(re.move, 2), moves(re.move, 3), moves(re.move, 4)) THEN EXIT FOR
    re.move = re.move + 1
   WEND
   IF Move.One(moves(re.move, 1), moves(re.move, 2), moves(re.move, 3), moves(re.move, 4)) THEN EXIT FOR
  NEXT re.move
  CALL Last.Card
 END IF
END IF
LOOP

error.trap:
COLOR color.set(7, 1, 0), color.set(7, 1, 1)
LOCATE 24, 1: PRINT "Error trap!                                         ";
STOP
RESUME

SUB Auto.Assist ()
SHARED layout(), moves(), move.no, automove!, lastcard()
DIM sort(8, 3)   ' m, n, layout(m,n)
' i and m are row subscripts (zero/non-zero)
' j and n are column subscripts
'         if row is zero then 1-4 are free cells
'                             5-8 are collected cells
'

auto.again:
' see if we have been canceled and do all required moves
IF automove! = 0 THEN EXIT SUB
CALL Must.Move

' clearing free cells and freeing single card rows maximizes moving space
LOCATE 24, 1: PRINT "Assist      ";

' see if you can clear any freecells
FOR j = 1 TO 4
 IF layout(0, j) THEN
  FOR n = 1 TO 8
   IF lastcard(n) THEN
    IF Move.Anything(0, j, 1, n) THEN GOTO auto.again
   END IF
  NEXT n
 END IF
NEXT j

' if you have any solitary rows, try to put them into free cells
FOR n = 1 TO 4: IF layout(0, n) = 0 THEN EXIT FOR
NEXT n
IF n < 5 THEN
Killed.One:
IF automove! = 0 THEN EXIT SUB
CALL Must.Move
 FOR j = 1 TO 8
  IF lastcard(j) = 1 THEN
   FOR k = 1 TO 4
    IF layout(0, k) THEN IF Move.Anything(0, k, 1, j) THEN GOTO Killed.One
   NEXT k
   FOR k = 1 TO 8
    l = lastcard(k)
    IF j <> k AND l THEN IF Move.All(l, k, 1, j) THEN GOTO Killed.One
   NEXT k
   IF Move.One(1, j, 0, n) THEN EXIT SUB ELSE GOTO auto.again
  END IF
 NEXT j
END IF

' sort the columns by the last cell in each column
sortm = 0
FOR n = 1 TO 8
 m = lastcard(n)
 IF m THEN
  sortm = sortm + 1: sort(sortm, 1) = m: sort(sortm, 2) = n: sort(sortm, 3) = layout(m, n)
 END IF
NEXT n
FOR i = 1 TO sortm: j = i
 FOR k = i + 1 TO sortm: IF (sort(k, 3) MOD 100) > (sort(j, 3) MOD 100) THEN j = k
 NEXT k
 IF j <> i THEN
  k = sort(i, 1): sort(i, 1) = sort(j, 1): sort(j, 1) = k
  k = sort(i, 2): sort(i, 2) = sort(j, 2): sort(j, 2) = k
  k = sort(i, 3): sort(i, 3) = sort(j, 3): sort(j, 3) = k
 END IF
NEXT i

' see which source can be moved
FOR sort0 = 1 TO sortm ' start with the largest one on down
 i = sort(sort0, 1): j = sort(sort0, 2)
 suit = layout(i, j) \ 100: pip = layout(i, j) MOD 100
 IF suit = 1 OR suit = 4 THEN
  uno = 201 + pip: duo = 301 + pip
 ELSE
  uno = 101 + pip: duo = 401 + pip
 END IF
 ' find the start of this group
 k = i - 1
 DO WHILE k > 0
  IF layout(k, j) = uno OR layout(k, j) = duo THEN
   k = k - 1: pip = pip + 1
   uno = 301 - 100 * (uno \ 100) + pip
   duo = 701 - 100 * (duo \ 100) + pip
  ELSE
   EXIT DO
  END IF
 LOOP
 ' ok see if you can move from k...i to m+1...
 FOR sort1 = 1 TO sort0 - 1
  IF sort(sort1, 3) = uno OR sort(sort1, 3) = duo THEN
   IF Move.Anything(i, j, sort(sort1, 1), sort(sort1, 2)) THEN GOTO auto.again
  END IF
 NEXT sort1

NEXT sort0

END SUB

SUB Auto.Solve ()
SHARED layout(), moves(), move.no, automove!, lastcard(), search!, test
SHARED leavefree
DIM sort(8, 4)   ' m, n, # non sequence cards, priority

IF INKEY$ = CHR$(27) THEN automove! = 0: search! = 0
IF automove! = 0 THEN EXIT SUB
CALL Auto.Assist
IF automove! = 0 THEN EXIT SUB

' find lowest pip
lowpip = 14
FOR n = 1 TO 8: FOR m = 1 TO lastcard(n)
 IF (layout(m, n) MOD 100) < lowpip THEN lowpip = layout(m, n) MOD 100
NEXT m: NEXT n
IF lowpip = 14 THEN  ' I don't think you can have an only card in a freecell
 IF search! THEN search! = automove!
 automove! = 0: EXIT SUB
END IF

' sort columns so's to start with the longest unsorted string
' except that if the column has the lowest pip in it, that goes first!
FOR n = 1 TO 8
 m = lastcard(n)
 sort(n, 1) = m: sort(n, 2) = n
 IF m THEN
  suit = layout(m, n) \ 100: pip = layout(m, n) MOD 100
  IF suit = 1 OR suit = 4 THEN
   uno = 201 + pip: duo = 301 + pip
  ELSE
   uno = 101 + pip: duo = 401 + pip
  END IF
  m = m - 1
  DO WHILE m > 0 AND (layout(m, n) = uno OR layout(m, n) = duo)
   m = m - 1: pip = pip + 1
   uno = 301 - 100 * (uno \ 100) + pip
   duo = 701 - 100 * (duo \ 100) + pip
  LOOP
  sort(n, 3) = m: sort(n, 4) = m
  DO WHILE m > 0
   IF (layout(m, n) MOD 100) = lowpip THEN
    IF sort(n, 3) < 20 THEN sort(n, 3) = 20 ELSE sort(n, 3) = sort(n, 3) + 20
   END IF
   m = m - 1
  LOOP
 ELSE
  sort(n, 3) = -1: sort(n, 4) = 0
 END IF
NEXT n
FOR i = 1 TO 7: j = i
 FOR k = i + 1 TO 8: IF (sort(k, 3) MOD 100) > (sort(j, 3) MOD 100) THEN j = k
 NEXT k
 IF j <> i THEN
  k = sort(i, 1): sort(i, 1) = sort(j, 1): sort(j, 1) = k
  k = sort(i, 2): sort(i, 2) = sort(j, 2): sort(j, 2) = k
  k = sort(i, 3): sort(i, 3) = sort(j, 3): sort(j, 3) = k
  k = sort(i, 4): sort(i, 4) = sort(j, 4): sort(j, 4) = k
 END IF
NEXT i
IF test THEN
 LOCATE 15, 1: PRINT "lastcard", "column", "priority", "cards left"
 FOR i = 1 TO 8
  PRINT sort(i, 1), sort(i, 2), sort(i, 3), sort(i, 4)
 NEXT i
END IF

smove = move.no ' come back here after every try
FOR sort0 = 1 TO 8
 '  OK see if you can clear out this column

keep.trying:
 LOCATE 24, 1: PRINT "Auto Solve  ";
 ' free cells and open columns:
 nfree = 0: FOR l = 1 TO 4: nfree = nfree - (layout(0, l) = 0): NEXT l
 lopen = 0: nopen = 0: FOR l = 1 TO 8
  IF layout(1, l) THEN  ELSE nopen = nopen + 1: lopen = l
 NEXT l
 nmove = (nfree + 1) * 2 ^ nopen
 IF nfree = 4 AND nopen = 8 THEN
  IF search! THEN search! = automove!:
  automove! = 0
 END IF
 IF automove! = 0 THEN EXIT SUB
 ' if moving to empty column  THEN use: nmove \ 2

 '  first try moving the end of this column to an empty column
 did.move.col = 0
 IF nopen > 0 AND sort(sort0, 3) > 0 THEN
 ' find out how many cards are on the bottom of this column
  jj = sort(sort0, 2)
  ii = lastcard(jj): iii = ii
  suit = layout(ii, jj) \ 100: pip = layout(ii, jj) MOD 100
  IF suit = 1 OR suit = 4 THEN
   uno = 201 + pip: duo = 301 + pip
  ELSE
   uno = 101 + pip: duo = 401 + pip
  END IF
  ii = ii - 1
  DO WHILE ii > 0 AND (layout(ii, jj) = uno OR layout(ii, jj) = duo)
   ii = ii - 1: pip = pip + 1
   uno = 301 - 100 * (uno \ 100) + pip
   duo = 701 - 100 * (duo \ 100) + pip
  LOOP
  IF iii - ii <= (nmove / 2) THEN
   ii = ii + 1
   ' OK we know we might want to move something from jj to lopen
   ' find the first step - can we start with a free cell
   CALL Put.Free(uno, duo, lopen)
   IF lastcard(lopen) = 0 THEN
    FOR l = 1 TO 8
     lc = lastcard(l)
     IF layout(lc, l) = uno OR layout(lc, l) = duo THEN
      temp = Move.Anything(lc, l, 1, lopen)
     END IF
    NEXT l
   END IF
   didmovecol = Move.Anything(ii, jj, 1, lopen)
   IF automove! = 0 THEN EXIT SUB
   IF didmovecol THEN
    CALL Auto.Solve
    IF automove! = 0 THEN EXIT SUB
    CALL Unmove(smove)
    IF automove! = 0 THEN EXIT SUB
   END IF
  END IF
 END IF

 IF NOT didmovecol THEN
  ' if we couldn't move to an open column, try moving this stuff to free cells
  IF (sort(sort0, 1) - sort(sort0, 4)) <= nfree AND sort(sort0, 4) > 0 THEN
   LOCATE 24, 1: PRINT "To free     ";
   FOR xx = sort(sort0, 4) + 1 TO sort(sort0, 1)
    temp = Move.Anything(sort(sort0, 1), sort(sort0, 2), 0, 1)
   NEXT xx
   CALL Auto.Assist
   ii = 0
   FOR jj = 1 TO 4: ii = ii + (layout(0, jj) = 0): NEXT jj
   FOR jj = 1 TO 8: ii = ii + (lastcard(jj) = 0): NEXT jj
   IF ii <= -leavefree THEN
    CALL Auto.Solve
   END IF
   IF automove! = 0 THEN EXIT SUB
   CALL Unmove(smove)
   IF automove! = 0 THEN EXIT SUB
  END IF
 END IF

 ' try moving this column to some other column
 IF sort(sort0, 3) >= 1 THEN
  FOR sort1 = sort0 + 1 TO 8
   IF sort(sort1, 3) < 20 AND sort(sort1, 3) >= 0 THEN
     LOCATE 24, 1: PRINT "try"; sort(sort0, 2); "to"; sort(sort1, 2);
     IF Move.Anything(1, sort(sort0, 2), 1, sort(sort1, 2)) THEN
      LOCATE 24, 1: PRINT "            ";
      CALL Auto.Solve
      IF automove! = 0 THEN EXIT SUB
      CALL Unmove(smove)
      IF automove! = 0 THEN EXIT SUB
     END IF
   END IF
  NEXT sort1
 END IF

NEXT sort0

' how about trying to put some free cells together?
FOR freecol = 1 TO 8
 IF lastcard(freecol) = 0 THEN EXIT FOR
NEXT freecol
IF freecol <= 8 THEN  ' we do have any empty column
 LOCATE 24, 1: PRINT "Combine Free";
 smove = move.no
 FOR i = 1 TO 4
  suit = layout(0, i) \ 100: pip = layout(0, i) MOD 100
  IF suit = 1 OR suit = 4 THEN
   uno = 201 + pip: duo = 301 + pip
  ELSE
   uno = 101 + pip: duo = 401 + pip
  END IF
  CALL Put.Free(uno, duo, freecol)
  IF lastcard(freecol) THEN
   FOR j = 1 TO 4
    temp = Move.Anything(0, j, 1, freecol)
   NEXT j
  END IF
  IF lastcard(freecol) THEN
   LOCATE 24, 1: PRINT "            ";
   CALL Auto.Solve
   IF automove! = 0 THEN EXIT SUB
   CALL Unmove(smove)
   IF automove! = 0 THEN EXIT SUB
  END IF
 NEXT i
END IF

' if nothing else works, try moving something to collection
FOR j = 1 TO 4: CALL Can.Play(0, j): NEXT j
FOR j = 1 TO 8: i = lastcard(j)
 IF i THEN CALL Can.Play(i, j)
NEXT j

END SUB

SUB Can.Play (i, j)

SHARED layout(), automove!, move.no
IF automove! = 0 THEN EXIT SUB
suit = layout(i, j) \ 100: pip = layout(i, j) MOD 100
IF layout(i, j) = layout(0, suit + 4) + 1 THEN
 smove = move.no
 LOCATE 24, 1: PRINT "Collect     ";
 IF Move.One(i, j, 0, suit + 4) THEN EXIT SUB
 CALL Auto.Solve
 IF automove! = 0 THEN EXIT SUB
 CALL Unmove(smove)
 IF automove! = 0 THEN EXIT SUB
END IF

END SUB

SUB Change.Color ()
SHARED color.set(), pip$(), suit$()
'
'  color fg=color.set(x,y,0), bg=color.set(x,y,1)
'
'  x = suit          0-4   =    " "
'  y = background
'
'  a$   description                color.set
' ----  -------------------------- ------------
'   0   normal on normal           5,   1
'   1   highlight on normal        6,   1
'   2   black on normal            1/4, 1
'   3   black on highlight         1/4, 2
'   4   black on pick              1/4, 3
'   5   red on normal              2/3, 1
'   6   red on highlight           2/3, 2
'   7   red on pick                2/3, 3
'   8   nothing on normal          0,   1
'   9   nothing on highlight       0,   2
'   :   nothing on pick            0,   3
'

a$ = "0": m = 5: n = 1: o = 2: p = 8: x$ = " 1 ": rules = -1

DO  ' change loop
COLOR color.set(7, 1, 0), color.set(7, 1, 1): CLS
COLOR color.set(5, 1, 0), color.set(5, 1, 1): LOCATE 1, 1
      '         1         2         3         4         5         6         7
      '12345678901234567890123456789012345678901234567890123456789012345678901234567890
PRINT "ͻ"' 1
PRINT "      1   2   3   4   5   6   7   8         Free Cells      "' 2
PRINT "    Ŀ   Ŀ   "' 3
PRINT "  1                                           "' 4
PRINT "  2                               "' 5
PRINT "  3                                Collected       "' 6
PRINT "  4                            Ŀ   "' 7
PRINT "  5                                           "' 8
PRINT "  6                               "' 9
PRINT "  7                                       Ŀ   "'10
PRINT "  8                              # Moves:        "'11
PRINT "ͼ"'12

IF rules THEN
 COLOR 7, 0
 PRINT " ͻ"'13
 PRINT "                                                               "'14
 PRINT "     (1) select a color box by pressing tab                    "'15
 PRINT "                                                               "'16
 PRINT "     (2) use left/right arrow to change background color       "'17
 PRINT "                                                               "'18
 PRINT "     (3) use up/down arrow to change foreground color          "'19
 PRINT "                                                               "'20
 PRINT "     (4) <M> for MDA colors, <V> for VGA colors, <ESC>         "'21
 PRINT "                                                               "'22
 PRINT " ͼ"'23
 rules = 0
ELSE
 COLOR 7, 0: PRINT "<"; color.set(m, n, 0); color.set(m, n, 1); ">"
 FOR i = 0 TO 7
  COLOR 7, 0: PRINT "x,"; i;
  FOR j = 0 TO 31
   COLOR j, i: PRINT USING "##"; j;
  NEXT j: PRINT
 NEXT
END IF

COLOR color.set(6, 1, 0), color.set(6, 1, 1)
LOCATE 2, 46: PRINT "Free Cells";
LOCATE 6, 46: PRINT "Collected";
LOCATE 11, 44: PRINT "# Moves:";

FOR j = 0 TO 5: column = 7 + 4 * j
 FOR i = 0 TO 7
  LOCATE 4 + i, column
  IF i > 5 THEN k = 0 ELSE k = 100 * (j \ 3) + i + 108
  COLOR color.set(k \ 100, 1 + j MOD 3, 0), color.set(k \ 100, 1 + j MOD 3, 1):
  PRINT pip$(k MOD 100); suit$(k \ 100);
 NEXT i
NEXT j
LOCATE 4, 31: COLOR color.set(3, 1, 0), color.set(3, 1, 1): PRINT pip$(8); suit$(3);
LOCATE 5, 31: COLOR color.set(3, 2, 0), color.set(3, 2, 1): PRINT pip$(9); suit$(3);
LOCATE 6, 31: COLOR color.set(3, 3, 0), color.set(3, 3, 1): PRINT pip$(10); suit$(3);
LOCATE 7, 31: COLOR color.set(4, 1, 0), color.set(4, 1, 1): PRINT pip$(11); suit$(4);
LOCATE 8, 31: COLOR color.set(4, 2, 0), color.set(4, 2, 1): PRINT pip$(12); suit$(4);
LOCATE 9, 31: COLOR color.set(4, 3, 0), color.set(4, 3, 1): PRINT pip$(13); suit$(4);


COLOR 7, 0
LOCATE o - 1, p - 1: PRINT "Ŀ"
    LOCATE o, p - 1: PRINT "   "
LOCATE o + 1, p - 1: PRINT ""
COLOR color.set(m, n, 0), color.set(m, n, 1): LOCATE o, p: PRINT x$;

DO: b$ = INKEY$: LOOP WHILE LEN(b$) = 0

IF b$ = CHR$(0) + CHR$(67) THEN b$ = CHR$(27)
IF LEN(b$) < 2 THEN
 IF ASC(b$) = 27 THEN
  OPEN "colors.fcc" FOR OUTPUT AS 1
  FOR i = 0 TO 7: FOR j = 1 TO 3: FOR k = 0 TO 1
   PRINT #1, color.set(i, j, k)
  NEXT k: NEXT j: NEXT i
  CLOSE 1
  EXIT DO
 ELSEIF ASC(b$) = 9 THEN
  a$ = CHR$(ASC(a$) + 1)
 ELSEIF UCASE$(b$) = "M" THEN
  ON ERROR GOTO forgetit
  OPEN "colormda.fcc" FOR INPUT AS 1
  FOR i = 0 TO 7: FOR j = 1 TO 3: FOR k = 0 TO 1
   INPUT #1, color.set(i, j, k)
  NEXT k: NEXT j: NEXT i
  CLOSE 1
 ELSEIF UCASE$(b$) = "V" THEN
  ON ERROR GOTO forgetit
  OPEN "colorvga.fcc" FOR INPUT AS 1
  FOR i = 0 TO 7: FOR j = 1 TO 3: FOR k = 0 TO 1
   INPUT #1, color.set(i, j, k)
  NEXT k: NEXT j: NEXT i
  CLOSE 1
 END IF
ELSE
 a = ASC(MID$(b$, 2))
 '--------------------------------------------' cursor movement --------------
 IF a = 71 THEN  ' Home
  color.set(m, n, 0) = 7
 ELSEIF a = 72 THEN  ' up
  color.set(m, n, 0) = (color.set(m, n, 0) + 31) MOD 32
 ELSEIF a = 75 THEN  ' left
  color.set(m, n, 1) = (color.set(m, n, 1) + 7) MOD 8
 ELSEIF a = 77 THEN  ' right
  color.set(m, n, 1) = (color.set(m, n, 1) + 1) MOD 8
 ELSEIF a = 79 THEN  ' end
  color.set(m, n, 1) = 0
 ELSEIF a = 80 THEN  ' down
  color.set(m, n, 0) = (color.set(m, n, 0) + 1) MOD 32
 ELSEIF a = 15 THEN
  a$ = CHR$(ASC(a$) - 1)
 END IF
END IF

IF a$ < "0" THEN a$ = ":" ELSE IF a$ > ":" THEN a$ = "0"
 IF a$ = "0" THEN m = 5: n = 1: o = 2: p = 8: x$ = " 1 "
 IF a$ = "1" THEN m = 6: n = 1: o = 2: p = 46: x$ = "Fre"
 IF a$ = "2" THEN m = 1: n = 1: o = 4: p = 7: x$ = pip$(8) + suit$(1)
 IF a$ = "3" THEN m = 1: n = 2: o = 4: p = 11: x$ = pip$(8) + suit$(1)
 IF a$ = "4" THEN m = 1: n = 3: o = 4: p = 15: x$ = pip$(8) + suit$(1)
 IF a$ = "5" THEN m = 2: n = 1: o = 4: p = 19: x$ = pip$(8) + suit$(2)
 IF a$ = "6" THEN m = 2: n = 2: o = 4: p = 23: x$ = pip$(8) + suit$(2)
 IF a$ = "7" THEN m = 2: n = 3: o = 4: p = 27: x$ = pip$(8) + suit$(2)
 IF a$ = "8" THEN m = 0: n = 1: o = 11: p = 7: x$ = "   "
 IF a$ = "9" THEN m = 0: n = 2: o = 11: p = 11: x$ = "   "
 IF a$ = ":" THEN m = 0: n = 3: o = 11: p = 15: x$ = "   "

' move spade/club or heart/diamond colors
IF a$ = "2" THEN
 color.set(4, 1, 0) = color.set(1, 1, 0): color.set(4, 1, 1) = color.set(1, 1, 1)
ELSEIF a$ = "3" THEN
 color.set(4, 2, 0) = color.set(1, 2, 0): color.set(4, 2, 1) = color.set(1, 2, 1)
ELSEIF a$ = "4" THEN
 color.set(4, 3, 0) = color.set(1, 3, 0): color.set(4, 3, 1) = color.set(1, 3, 1)
ELSEIF a$ = "5" THEN
 color.set(3, 1, 0) = color.set(2, 1, 0): color.set(3, 1, 1) = color.set(2, 1, 1)
ELSEIF a$ = "6" THEN
 color.set(3, 2, 0) = color.set(2, 2, 0): color.set(3, 2, 1) = color.set(2, 2, 1)
ELSEIF a$ = "7" THEN
 color.set(3, 3, 0) = color.set(2, 3, 0): color.set(3, 3, 1) = color.set(2, 3, 1)
END IF

LOOP WHILE 1

END SUB

SUB Last.Card ()
SHARED lastcard(), layout()
FOR j = 1 TO 8
 FOR i = 19 TO 1 STEP -1
  IF layout(i, j) THEN EXIT FOR
 NEXT i
 lastcard(j) = i
NEXT j

END SUB

FUNCTION Move.All (i%, j%, m%, n%)
SHARED layout(), moves(), move.no, lastcard()
' Check to see if a complete string can be moved
Move.All = 0

' check to see how long this string is
suit = layout(i, j) \ 100: pip = layout(i, j) MOD 100
IF suit = 1 OR suit = 4 THEN
 uno = 201 + pip: duo = 301 + pip
ELSE
 uno = 101 + pip: duo = 401 + pip
END IF
k = i - 1
DO WHILE k > 0 AND (layout(k, j) = uno OR layout(k, j) = duo)
 k = k - 1: pip = pip + 1
 uno = 301 - 100 * (uno \ 100) + pip
 duo = 701 - 100 * (duo \ 100) + pip
LOOP

IF layout(m, n) = uno OR layout(m, n) = duo THEN
 Move.All = Move.Anything(i, j, m, n)
END IF

END FUNCTION

' I1 is from row - zero row contains free cells / collected cells
'                  non zero rows contain layout
' J1 is the from column
'                - row zero 1-4 are the free cells, 5-8 collected cells
' M1 is the destination row, N1 is the destination column
'
' see if there is any way to copy I1 to M1
'        J1 and N1 are only used to determine zero/non zero
' return -1 if yes, 0 if no
'
FUNCTION Move.Anything% (i1, j1, m1, n1)

SHARED layout(), moves(), move.no, lastcard()
i = i1: j = j1: m = m1: n = n1: k1 = i
Move.Anything% = 0

' can't move from an MT column
IF i THEN
 i = lastcard(j): IF i = 0 THEN EXIT FUNCTION
ELSE
' or an empty free cell or any collected cell
 IF layout(i, j) = 0 OR j > 4 THEN EXIT FUNCTION
END IF

' are we just moving one card to a free/collected cell
IF m = 0 THEN
 IF n < 5 THEN  ' free cell
  FOR n = 1 TO 5: IF layout(m, n) = 0 THEN EXIT FOR
  NEXT n
  IF n > 4 THEN EXIT FUNCTION
 ELSE           ' collected cell
  n = 4 + layout(i, j) \ 100
  IF (layout(m, n) + 1) <> layout(i, j) THEN EXIT FUNCTION
 END IF
 ' OK to move it
 IF Move.One(i, j, m, n) THEN EXIT FUNCTION
 Move.Anything = -1: EXIT FUNCTION
END IF

' moving to the layout, find --> rouge on noire
m = lastcard(n)
IF m THEN
 card = layout(m, n)
 suit = card \ 100: pip = card MOD 100
 IF suit = 1 OR suit = 4 THEN
  one = 199 + pip: two = 299 + pip
 ELSE
  one = 99 + pip: two = 399 + pip
 END IF
END IF

m = m + 1        ' destination cell
IF i = 0 THEN ' moving a free cell back to the layout
 IF m <> 1 AND layout(0, j) <> one AND layout(0, j) <> two THEN EXIT FUNCTION
 Move.Anything = NOT Move.One(i, j, m, n): EXIT FUNCTION
END IF

' free cells and open columns:
nfree = 0: FOR l = 1 TO 4: nfree = nfree - (layout(0, l) = 0): NEXT l
nopen = 0: FOR l = 1 TO 8: nopen = nopen - (layout(1, l) = 0): NEXT l
nmove = (nfree + 1) * 2 ^ nopen
IF m = 1 THEN nmove = nmove \ 2  ' moving to an empty column

' How far up the stack should/can we go
IF layout(1, n) OR (k1 < (i - nmove + 1)) THEN k1 = i - nmove + 1
IF k1 < 1 THEN k1 = 1

k = i
DO WHILE k > k1
 ' is this the card we are looking for
 card = layout(k, j)
 IF m > 1 THEN IF card = one OR card = two THEN EXIT DO
 ' is the next card in sequence
 suit = card \ 100: pip = card MOD 100
 IF suit = 1 OR suit = 4 THEN
  uno = 201 + pip: duo = 301 + pip
 ELSE
  uno = 101 + pip: duo = 401 + pip
 END IF
 k = k - 1
 IF NOT (layout(k, j) = uno OR layout(k, j) = duo) THEN
  IF m > 1 THEN EXIT FUNCTION ELSE k = k + 1: EXIT DO
 END IF
LOOP

card = layout(k, j)
IF m > 1 THEN IF card = one OR card = two THEN  ELSE EXIT FUNCTION

CALL Move.Many(i, j, m, n, k)
Move.Anything% = -1

END FUNCTION

SUB Move.Many (i1, j1, m1, n1, k1)
' validity of move has been confirmed

DIM mtfree(3), mtopen(8)
SHARED layout(), moves(), move.no, lastcard(), test

' move k,j ... i,j to m,n ... m+i-k,n  (k < i)

i = i1: j = j1: m = m1: n = n1: k = k1

' first find the empty free cells
nfree = 0: FOR l = 1 TO 4: IF layout(0, l) = 0 THEN mtfree(nfree) = l: nfree = nfree + 1
NEXT l
' then the empty columns
nopen = 0: FOR l = 1 TO 8: IF layout(1, l) = 0 THEN IF l <> n THEN nopen = nopen + 1: mtopen(nopen) = l
NEXT l
' nfree is # of free cells, stored in mtfree(0..(nfree-1))
' nopen is # of open columns, stored in mtopen(1..nopen)
'
shift.to = k + nfree + 1: start.moves = move.no

IF i + 1 - k <= (nopen + 1) * (nfree + 1) THEN ' we can do simple move
 ' '''' most number of cards that can be moved
 ' # of moves:       nfree =   0 1 2 3 4
 '                nopen    ͻ
 '                    0       1 2 3 4 5  
 '                    1       2 4 6 810  
 '                    2       3 6 912xx  
 '                    3       4 812xxxx  
 '                    4       51015xxxx  
 '                    5       612xxxxxx  
 '                    6       7xxxxxxxx  
 '                         ͼ
 WHILE lastcard(j) >= shift.to
  IF lastcard(mtopen(1)) = 0 THEN
   CALL Move.Stack(j, mtopen(1), shift.to)  ' move to first open column
  ELSEIF lastcard(mtopen(2)) = 0 THEN
    CALL Move.Stack(j, mtopen(2), shift.to) ' move to second column
  ELSEIF lastcard(mtopen(3)) = 0 THEN
    CALL Move.Stack(j, mtopen(3), shift.to)
  ELSEIF lastcard(mtopen(4)) = 0 THEN
    CALL Move.Stack(j, mtopen(4), shift.to)
  ELSEIF lastcard(mtopen(5)) = 0 THEN
    CALL Move.Stack(j, mtopen(5), shift.to)
  ELSEIF lastcard(mtopen(6)) = 0 THEN
    CALL Move.Stack(j, mtopen(6), shift.to)
  ELSEIF lastcard(mtopen(7)) = 0 THEN
    CALL Move.Stack(j, mtopen(7), shift.to)
  ELSE
    CALL Move.Stack(j, mtopen(8), shift.to)
  END IF
 WEND

 end.moves = move.no
 CALL Move.Stack(j, n, k)  ' move last few cards
 end.moves1 = move.no
 CALL Must.Move
 IF end.moves1 <> move.no THEN EXIT SUB

 DO WHILE end.moves > start.moves
  ii = moves(end.moves, 1)
  jj = moves(end.moves, 2)
  mm = moves(end.moves, 3)
  nn = moves(end.moves, 4)
  IF jj = j AND ii > 0 THEN jj = n
  IF ii > 0 THEN ii = lastcard(jj) + 1
  IF Move.One(mm, nn, ii, jj) THEN EXIT SUB
  end.moves = end.moves - 1
 LOOP
 EXIT SUB
END IF

' '''' most number of cards that can be moved
' # of moves:       nfree =   0 1 2 3 4
'                nopen    ͻ
'                    0       1 2 3 4 5  
'                    1       2 4 6 810  
'                    2       4 81216xx  
'                    3       816xxxxxx  
'                    4      16xxxxxxxx  
'                         ͼ

WHILE lastcard(j) >= shift.to
 IF lastcard(mtopen(1)) = 0 THEN
  CALL Move.Stack(j, mtopen(1), shift.to)  ' move to first open column
 ELSEIF lastcard(mtopen(2)) = 0 THEN
   CALL Move.Stack(j, mtopen(2), shift.to) ' move to second column
   CALL Move.Stack(mtopen(1), mtopen(2), 1)
 ELSEIF lastcard(mtopen(3)) = 0 THEN
   CALL Move.Stack(j, mtopen(3), shift.to)
   CALL Move.Stack(mtopen(1), mtopen(3), 1)
   CALL Move.Stack(mtopen(2), mtopen(1), 1)
   CALL Move.Stack(mtopen(2), mtopen(3), 1)
   CALL Move.Stack(mtopen(1), mtopen(3), 1)
 ELSE
   CALL Move.Stack(j, mtopen(4), shift.to)
   CALL Move.Stack(mtopen(1), mtopen(4), 1)
   CALL Move.Stack(mtopen(2), mtopen(1), 1)
   CALL Move.Stack(mtopen(2), mtopen(4), 1)
   CALL Move.Stack(mtopen(1), mtopen(4), 1)
   CALL Move.Stack(mtopen(3), mtopen(1), 1)
   CALL Move.Stack(mtopen(3), mtopen(2), 1)
   CALL Move.Stack(mtopen(1), mtopen(2), 1)
   CALL Move.Stack(mtopen(3), mtopen(1), 1)
   CALL Move.Stack(mtopen(3), mtopen(4), 1)
   CALL Move.Stack(mtopen(1), mtopen(4), 1)
   CALL Move.Stack(mtopen(2), mtopen(1), 1)
   CALL Move.Stack(mtopen(2), mtopen(4), 1)
   CALL Move.Stack(mtopen(1), mtopen(4), 1)
 END IF
WEND

end.moves = move.no
CALL Move.Stack(j, n, k)  ' move last few cards
end.moves1 = move.no
CALL Must.Move
IF end.moves1 <> move.no THEN EXIT SUB

DO WHILE end.moves > start.moves
 ii = moves(end.moves, 1)
 jj = moves(end.moves, 2)
 mm = moves(end.moves, 3)
 nn = moves(end.moves, 4)
 IF jj = j AND ii > 0 THEN jj = n
 IF ii > 0 THEN ii = lastcard(jj) + 1
 IF Move.One(mm, nn, ii, jj) THEN EXIT SUB
 end.moves = end.moves - 1
LOOP

END SUB

' assume move is valid and save it in moves array
FUNCTION Move.One% (i, j, m, n)
SHARED layout(), moves(), move.no, automove!, test, lastcard(), color.set()
SHARED pip$(), suit$(), highi, highj, youdeal, stopatstep

' check for validity
Move.One% = -1
IF youdeal = 0 THEN IF i > 0 AND lastcard(j) <> i THEN PRINT i; j; m; n; : STOP: EXIT FUNCTION
IF m > 0 AND lastcard(n) <> (m - 1) THEN PRINT i; j; m; n; : STOP: EXIT FUNCTION
IF m > 0 AND layout(m, n) > 0 THEN PRINT i; j; m; n; : STOP: EXIT FUNCTION

IF stopatstep > 0 AND stopatstep <= automove! THEN
 stopatstep = 0: test = -1
 LOCATE 21, 63: PRINT "             ";
 LOCATE 22, 63: PRINT "             ";
 LOCATE 23, 63: PRINT "             ";
END IF

card = layout(i, j)
IF test THEN
 COLOR color.set(card \ 100, 1, 1), color.set(card \ 100, 1, 0)
 IF i = 0 THEN
  IF j < 5 THEN
   LOCATE 4, 39 + 4 * j
  ELSE
   LOCATE 8, 23 + 4 * j
  END IF
 ELSE
  LOCATE i + 3, 3 + 4 * j
 END IF
 PRINT pip$(card MOD 100); suit$(card \ 100);
 LOCATE 24, 14: COLOR 0, 15: PRINT "AUTO.MOVE? <Y/N/C> ?";
 DO: a$ = INKEY$: LOOP WHILE LEN(a$) = 0
 LOCATE 24, 14: COLOR 15, 0: PRINT "                    ";
 a$ = UCASE$(LEFT$(a$, 1))
 IF a$ = CHR$(27) THEN STOP
 IF a$ = "C" THEN test = 0
 IF a$ = "N" THEN automove! = 0: test = 0: EXIT FUNCTION
ELSE
 IF automove! = 0 THEN speed = 8: x! = INT(speed * TIMER): WHILE x! = INT(speed * TIMER): WEND
END IF

Move.One% = 0
layout(m, n) = layout(i, j): layout(i, j) = 0
move.no = move.no + 1
moves(move.no, 1) = i
moves(move.no, 2) = j
moves(move.no, 3) = m
moves(move.no, 4) = n
IF m THEN lastcard(n) = lastcard(n) + 1
IF youdeal = 0 THEN IF i THEN lastcard(j) = lastcard(j) - 1
CALL Show.Board

IF automove! > 0 THEN automove! = automove! + 1: LOCATE 24, 40: PRINT automove!; SPACE$(20);

EXIT FUNCTION

' verify that all of the cards are still on the board

cc = 0
FOR jj = 1 TO 8
 cc = cc + lastcard(jj)
NEXT jj
FOR jj = 1 TO 4
 cc = cc - (layout(0, jj) <> 0)
NEXT jj
FOR jj = 5 TO 8
 cc = cc + layout(0, jj) MOD 100
NEXT jj
IF cc <> 52 THEN
 STOP
END IF

END FUNCTION

SUB Move.Stack (from.col, to.col, down.to)
DIM mtfree(3)
SHARED layout(), lastcard()

' find the empty free cells
nfree = 0: FOR l = 1 TO 4: IF layout(0, l) = 0 THEN mtfree(nfree) = l: nfree = nfree + 1
NEXT l
mfree = 0

WHILE mfree < nfree AND lastcard(from.col) > down.to
 lcf = lastcard(from.col)
 IF Move.One(lcf, from.col, 0, mtfree(mfree)) THEN EXIT SUB
 mfree = mfree + 1: WEND

IF lastcard(from.col) >= down.to THEN
 lcf = lastcard(from.col): lct = lastcard(to.col) + 1
 IF Move.One(lcf, from.col, lct, to.col) THEN EXIT SUB
END IF

WHILE mfree
 mfree = mfree - 1: lct = lastcard(to.col) + 1
 IF Move.One(0, mtfree(mfree), lct, to.col) THEN EXIT SUB
 WEND

END SUB

' check each column to see if there is a MUST move
SUB Must.Move ()
SHARED layout(), lastcard(), highi, highj

savehighi = highi: savehighj = highj
LOCATE 24, 1: PRINT "Must.move   ";
mustagain:
FOR j = 1 TO 4: IF Must.Play(0, j) THEN GOTO mustagain
NEXT j
FOR j = 1 TO 8: i = lastcard(j)
 IF i > 0 THEN IF Must.Play(i, j) THEN GOTO mustagain
NEXT j
highi = savehighi: highj = savehighj

END SUB

' check one location to see if the card needs to be collected
FUNCTION Must.Play (i, j)
SHARED layout()
Must.Play = 0
card = layout(i, j): suit = card \ 100: pip = card MOD 100
' 5=spade, 6=heart, 7=diamond, 8=club on collection stacks (suit+4)
IF card = layout(0, suit + 4) + 1 THEN
 ' we may need this card if either suit of the opposite color
 '    still hasn't got the pip-1 card
 IF pip > 2 THEN
 IF suit = 1 OR suit = 4 THEN
  IF (layout(0, 4 + 2) <= (200 - 2 + pip)) OR (layout(0, 4 + 3) <= (300 - 2 + pip)) THEN EXIT FUNCTION
 ELSE
  IF (layout(0, 4 + 1) <= (100 - 2 + pip)) OR (layout(0, 4 + 4) <= (400 - 2 + pip)) THEN EXIT FUNCTION
 END IF
 END IF
 IF Move.One(i, j, 0, suit + 4) THEN EXIT FUNCTION
 Must.Play = -1
END IF

END FUNCTION

SUB new.game () '  shuffle and deal
DIM sort!(52, 2)
SHARED layout(), file.name$
file.name$ = ""
FOR i = 7 TO 19:
FOR j = 1 TO 8: layout(i, j) = 0: NEXT j: NEXT i
FOR i = 13 TO 64: sort!(i - 12, 2) = RND
 sort!(i - 12, 1) = ((i \ 13) * 100) + (i MOD 13) + 1: NEXT i
FOR i = 1 TO 51: FOR j = i + 1 TO 52
 IF sort!(j, 2) < sort!(i, 2) THEN
  t! = sort!(i, 1): sort!(i, 1) = sort!(j, 1): sort!(j, 1) = t!
  t! = sort!(i, 2): sort!(i, 2) = sort!(j, 2): sort!(j, 2) = t!
 END IF
NEXT j: NEXT i
i = 1: j = 1
FOR k = 1 TO 52: layout(i, j) = sort!(k, 1)
 j = j + 1: IF j > 8 THEN i = i + 1: j = 1
NEXT k
END SUB

SUB Put.Free (egy, keto, nn)
' check to see if there is a free cell card matching egy/keto
' if there is, put it into column nn
SHARED layout(), lastcard(), test

FOR l = 1 TO 4
 IF layout(0, l) = egy OR layout(0, l) = keto THEN
  pip = egy MOD 100
  egy = 301 - 100 * (egy \ 100) + pip
  keto = 701 - 100 * (keto \ 100) + pip
  CALL Put.Free(egy, keto, nn)
  IF Move.One(0, l, lastcard(nn) + 1, nn) THEN EXIT SUB
  EXIT FOR
 END IF
NEXT

END SUB

FUNCTION Scan$ (x$, z$)

y$ = ""
WHILE 1
 LOCATE 24, 1
 IF LEN(y$) THEN
  PRINT x$ + ": " + y$ + "_"; SPACE$(75 - LEN(x$ + y$));
 ELSE
  PRINT x$ + ": " + z$ + SPACE$(76 - LEN(x$ + z$));
 END IF
 DO: a$ = INKEY$: LOOP WHILE LEN(a$) = 0
 IF a$ = CHR$(8) THEN
  IF LEN(y$) > 0 THEN y$ = LEFT$(y$, LEN(y$) - 1)
 ELSEIF a$ = CHR$(13) OR LEN(a$) > 1 THEN
  IF LEN(y$) = 0 THEN Scan$ = z$ ELSE Scan$ = y$
  GOTO retur
 ELSEIF a$ = CHR$(27) THEN
  Scan$ = "": GOTO retur
 ELSE
  y$ = y$ + a$
 END IF
WEND

retur:
 LOCATE 24, 1: PRINT SPACE$(78);

END FUNCTION

SUB Show.Board ()
SHARED color.set(), layout(), pip$(), suit$()
SHARED picki, pickj, highi, highj, youdeal, move.no, automove!
SHARED lastcard(), funckey, search.count, test

' moves
COLOR color.set(6, 1, 0), color.set(6, 1, 1): LOCATE 1, 1
LOCATE 11, 54: PRINT USING "####"; move.no;

' free cells
i = 0: FOR j = 1 TO 4
 pick = pickj = j AND ((picki = i) OR (NOT youdeal AND NOT ((picki = 0) XOR (i = 0))))
 IF pick THEN thiscolor = 3 ELSE IF highi = i AND highj = j THEN thiscolor = 2 ELSE thiscolor = 1
 LOCATE 4, 39 + 4 * j: COLOR color.set(layout(i, j) \ 100, thiscolor, 0), color.set(layout(i, j) \ 100, thiscolor, 1): PRINT pip$(layout(i, j) MOD 100); suit$(layout(i, j) \ 100);
NEXT j

' collected cells
i = 0: FOR j = 5 TO 8
 IF highi = i AND highj = j THEN thiscolor = 2 ELSE thiscolor = 1
 LOCATE 8, 23 + 4 * j: COLOR color.set(layout(i, j) \ 100, thiscolor, 0), color.set(layout(i, j) \ 100, thiscolor, 1): PRINT pip$(layout(i, j) MOD 100); suit$(layout(i, j) \ 100);
NEXT j

' layout
FOR i = 1 TO 19
 FOR j = 1 TO 8
 pick = pickj = j AND ((picki = i) OR (NOT youdeal AND NOT ((picki = 0) XOR (i = 0))))
 IF highi = i AND highj = j THEN thiscolor = 2 ELSE IF pick THEN thiscolor = 3 ELSE thiscolor = 1
 ' IF lastcard(j) = i THEN thiscolor = 3
 LOCATE i + 3, 3 + 4 * j: COLOR color.set(layout(i, j) \ 100, thiscolor, 0), color.set(layout(i, j) \ 100, thiscolor, 1): PRINT pip$(layout(i, j) MOD 100); suit$(layout(i, j) \ 100);
NEXT j: NEXT i

COLOR color.set(6, 1, 0), color.set(6, 1, 1)
IF funckey THEN
 LOCATE 12 + funckey, 42
 SELECT CASE funckey
  CASE 1
   PRINT "F1: Help           "
  CASE 2
   PRINT "F2: Restart        "
  CASE 3
   PRINT "F3: New Deal       "
  CASE 4
   PRINT "F4: You Deal       "
  CASE 5
   PRINT "F5: Auto Assist    "
  CASE 6
   PRINT "F6: Auto Solve     "
  CASE 7
   PRINT "F7: Save Deal      "
  CASE 8
   PRINT "F8: Load Old Deal  "
  CASE 9
   PRINT "F9: Change colors  "
  CASE 10
   PRINT "F10: Undo Last Play"
  END SELECT
END IF
IF search.count THEN LOCATE 1, 64: PRINT search.count
COLOR 15, 0
LOCATE 2, 64: IF test THEN PRINT "Test Mode";  ELSE PRINT "         ";

END SUB

FUNCTION Trim$ (x$)
trim.cut:
IF LEN(x$) = 0 THEN Trim$ = "freecell": EXIT FUNCTION
IF RIGHT$(x$, 1) = " " THEN x$ = LEFT$(x$, LEN(x$) - 1): GOTO trim.cut
Trim$ = x$
END FUNCTION

SUB Unmove (down.to)

SHARED layout(), moves(), move.no, lastcard(), test, automove!
SHARED pip$(), suit$(), highi, highj, youdeal, picki, pickj

LOCATE 24, 1: PRINT "Unmove to"; down.to;
IF test THEN
 LOCATE 24, 14: COLOR 0, 15: PRINT "AUTO.MOVE? <Y/N/C> ?";
 DO: a$ = INKEY$: LOOP WHILE LEN(a$) = 0
 LOCATE 24, 14: COLOR 15, 0: PRINT "                    ";
 a$ = UCASE$(LEFT$(a$, 1))
 IF a$ = CHR$(27) THEN STOP
 IF a$ = "C" THEN test = 0
 IF a$ = "N" THEN automove! = 0: test = 0: EXIT SUB
END IF

another.one:
IF down.to >= move.no THEN
 CALL Show.Board
 EXIT SUB
END IF

COLOR 15, 0
highi = moves(move.no, 1): highj = moves(move.no, 2): m = moves(move.no, 3): n = moves(move.no, 4)
layout(highi, highj) = layout(m, n)

IF youdeal THEN
 picki = m: pickj = n
ELSE
 IF highi THEN lastcard(highj) = lastcard(highj) + 1
END IF
IF m THEN lastcard(n) = lastcard(n) - 1

IF m = 0 AND n > 4 THEN layout(0, n) = layout(0, n) - 1 ELSE layout(m, n) = 0
move.no = move.no - 1

GOTO another.one

END SUB

